/*
 * List.h
 *
 *  Created on: Oct 14, 2008
 *  Revised Oct 2009
 *      Author: bloch
 */

#ifndef LIST_H_
#define LIST_H_

template<typename ElementType> class List {
public:
	List<ElementType>() {}
	virtual int length() const = 0;
	// note that this method is "pure virtual", equivalent to an
	// abstract method in Java
	virtual bool isEmpty() const = 0;

	virtual std::ostream& printList (std::ostream &out) const = 0;
	virtual bool operator==(const List<ElementType> &other) const = 0;
	bool operator!=(const List<ElementType> &other) const {
		return ! (*this == other);
	}
	virtual ~List();
};

template<typename ElementType> std::ostream& operator<< (std::ostream& out, const List<ElementType> &theList) {
	out << "[";
	return theList.printList(out) << "]";
}


template<typename ElementType> List<ElementType>::~List() {
}

#endif /* LIST_H_ */
